
/* by Luis Figueiredo (stdio@netc.pt)
 *
 *
 * date: Wed Oct  9 19:05:48 GMT 2002
 *
 *
 * --
 *
 */

#ifndef _CLIENTINFO_H_
#define _CLIENTINFO_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <fcntl.h>
#include <string.h>

#include "outstream.h"
#include "client.h"
#include "utils.h"
#include "memory.h"


/*
 * Next's structs are redudant but it is an case of logic
 */
struct _Header {
        char *id;
        char *data;
        struct _Header *next;
};
struct _Query {
	char *id;
	char *data;
	struct _Query *next;
};
struct _Post {
	char *id;
	char *data;
	struct _Post *next;
};

struct _MultiPart {
	char *id;
	char *data;
	unsigned int size;
	char *filename;
	struct _MultiPart *next;
};


struct ClientInfo {
	int outfd;
	char *inetname;
	char *request;
	char *method;
	char *user;
	char *pass;
	char *QueryString;
	char *PostData;
	char *CookieString;
	char *(*Header)(char *);
	char *(*Query)(char *);
	char *(*Post)(char *);
	char *(*Cookie)(char *); // TODO
	struct _MultiPart (*MultiPart)(char *); // TODO (NEW)
	// not necessary for web_server.h
	struct memrequest *mem;
	struct _Header *HeaderList; // Not necessary for web_server.h
	struct _Query *QueryList; // Not necessary for web_server.h
	struct _Post *PostList; // Not necessary for web_server.h
	struct _MultiPart *MultiPartList; // Not necessary for web_server.h
};      // PROTOTYPE


void init_clientinfo();
void free_clientinfo();
char *clientinfo_getauthuser();
char *clientinfo_getauthpass();
char *clientinfo_getquerystring();
char *clientinfo_getpostdata();
char *clientinfo_getcookiestring();
char *clientinfo_getmethod();
char *clientinfo_getreqname();
char *__Header(char *);
char *__Query(char *);
char *__Post(char *);
struct _MultiPart __MultiPart(char *);

#endif

