/* by Luis Figueiredo (stdio@netc.pt)
 *
 *
 * date: Sat Mar 30 14:25:25 GMT 2002 
 *
 *  memory functions
 */

#ifndef _MEMORY_H_
#define _MEMORY_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif         


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "debug.h"

extern int errno;

void *mymalloc(size_t);
void *mycalloc(size_t,size_t);
void *myrealloc(void *,size_t);
void myfree(void *);

struct memrequest {
	char *ptr;
	struct memrequest *next;
};
struct memrequest *init_buffer_list();
void *add_buffer(struct memrequest *,unsigned int);
void delete_buffer(struct memrequest *);
void delete_next_buffer(struct memrequest *);
void delete_buffer_list(struct memrequest *);

#endif
