/*
 * Fri Dec 28 12:51:11 GMT 2001
 *      Luis Figueiredo -- I Corrected the input to handle only data when \n\r(twice) is arrived
 *
 * Mon Feb 25 06:27:58 GMT 2002
 *      Luis Figueiredo -- Many corrections and new functions were added, until today
 *
 * Mon Mar 25 14:46:13 GMT 2002
 *      Luis Figueiredo -- wow, one month later..., discard web_server_addstr, and now process the stdout to server
 *                         using a tmpfile for streaming (not so good, but :o))
 * Wed Mar 27 18:59:10 GMT 2002
 *      Luis Figueiredo -- using regex instead of fnmatch(fnmatch only appears becouse of apache, i didn't knew it)
 * Mon Apr  8 15:04:31 GMT 2002
 *	Luis Figueiredo -- Oh my.. kurt cobain is dead :o), restructured the code, separated into various files                                                                 
 * Wed Apr 10 20:02:55 GMT 2002
 *	Luis Figueiredo -- Make use of autoconf , removed open_memstream (doesn't work well w/ stdout structure on netbsd portability)
 *                         linux slack 7.1 uses "extern FILE *stdout", netbsd uses "extern FILE __sF[]" so i cannot make use of pointers
 * Mon Oct  7 16:56:15 GMT 2002
 *      Luis Figueiredo -- Repaired some safe bugs, Added vars to stats proposes, inserted an liblogo, added debug instructions
 */
#ifndef _WEB_SERVER_H_
#define _WEB_SERVER_H_

#include <stdio.h> // for struct FILE

extern char *_libwebserver_version;


struct _MultiPart {
        char *id;
        char *data;
        unsigned int size;
        char *filename;
	void *pad;
};

extern struct ClientInfo {
        int outfd;
        char *inetname;
        char *request;
	char *method;
        char *user;
        char *pass;
	char *QueryString;
	char *PostData;
	char *CookieString;
        char *(*Header)(char *);
        char *(*Query)(char *);
        char *(*Post)(char *);
        char *(*Cookie)(char *);
	struct _MultiPart (*MultiPart)(char *); // TODO (NEW)
	void *__pad[5];

} *ClientInfo;      // PROTOTYPE    


struct web_server {
        int socket;
        FILE *weblog;
	int flags;
        struct gethandler *gethandler;
        struct web_client *client;
	int usessl;
	void *pad[2];    // SSL pad
        struct {
                unsigned long long connection;
                unsigned long long bsent;
                unsigned long long brecv;
        }stat;            
};                                                                                                                             
#define WS_LOCAL 1 	// Can be only accessed by localhost (usefull for local programs gui's)
#define WS_USESSL 2     // Use ssl conections (openssl lib required) (security transation) (there is no sense using WS_LOCAL & WS_USESSL together)

void web_server_useSSLcert(struct web_server *,const char *);  // unusefull if not using openssl
int web_server_init(struct web_server *,int,const char *,int);
int web_server_addhandler(struct web_server *,const char *,void (*)(),int);
int web_server_run(struct web_server *);
int web_client_addstream(FILE *);
int web_client_addfile(char *file);
char *web_client_getreqline();
char *web_client_getreqhost(); 

void web_client_HTTPdirective(char *);   
void web_log(const char *,...);           

unsigned long web_server_statconnections();
unsigned long web_server_statsent();
unsigned long web_server_statrecv();


#endif

