/* by Luis Figueiredo (stdio@netc.pt)
 *
 *
 * date: Wed Oct  9 19:56:22 GMT 2002
 *
 *
 * -- parse http header into "ClientInfo"
 *
 */

#include "clientinfo.h"


struct ClientInfo *ClientInfo=NULL;   

void init_clientinfo() { // NEW
        struct outstream *tstream=current_web_client->outstream;
	char *t;
	IFDEBUG(fprintf(stderr,"clientinfo.c: (allocating ClientInfo): "));
	ClientInfo=mymalloc(sizeof(struct ClientInfo));
        while(tstream->next!=NULL) {
                tstream=tstream->next;
        };
        if(tstream->fstream!=NULL) ClientInfo->outfd=fileno(tstream->fstream);
	ClientInfo->mem=init_buffer_list(); // First thing other fuctions use this to allocate
        
	ClientInfo->request=clientinfo_getreqname();
	/*t=inet_ntoa(current_web_client->sa.sin_addr);
	ClientInfo->inetname=add_buffer(strlen(t)+1);
	memcpy(ClientInfo->inetname,t,strlen(t));
	ClientInfo->inetname[strlen(t)]='\0';*/
	ClientInfo->inetname=NULL;
	ClientInfo->method=clientinfo_getmethod();
	ClientInfo->user=clientinfo_getauthuser();
	ClientInfo->pass=clientinfo_getauthpass();
	/* Initialize Header List */
	ClientInfo->HeaderList=NULL;
	ClientInfo->QueryList=NULL;
	ClientInfo->PostList=NULL;
	ClientInfo->MultiPartList=NULL;

	ClientInfo->Header=__Header;
	ClientInfo->Query=__Query;
	ClientInfo->QueryString=clientinfo_getquerystring();	
	ClientInfo->Post=__Post;
	ClientInfo->PostData=clientinfo_getpostdata();	
	ClientInfo->MultiPart=__MultiPart;
	//ClientInfo->CookieString=clientinfo_getcookiestring();
}                      

void free_clientinfo() {
	if(ClientInfo==NULL) {	
		return;
	};
	delete_buffer_list(ClientInfo->mem); 
	IFDEBUG(fprintf(stderr,"clientinfo.c: (freeing Clientinfo): "));
	myfree(ClientInfo);
	ClientInfo=NULL;
}

char *__Header(char *str) {
        char *tmp1,*tmp2,*tmp3,*ret;
	struct _Header *hl=ClientInfo->HeaderList;
	char *defret="";
        size_t size;
        size_t strsize;
	if(ClientInfo->HeaderList==NULL) {
		IFDEBUG(fprintf(stderr,"Header list is NULL adding head to header list\n"));
		ClientInfo->HeaderList=add_buffer(ClientInfo->mem,sizeof(struct _Header));
		ClientInfo->HeaderList->next=NULL;
		ClientInfo->HeaderList->data=NULL;
		ClientInfo->HeaderList->id=NULL;
		hl=ClientInfo->HeaderList;
	};
	// First search if exists
	IFDEBUG(fprintf(stderr,"Entering in Header\n"));
	while(hl->next!=NULL) {
		if(hl->next->id!=NULL) {
			if(!strcmp(hl->next->id,str)) {
				IFDEBUG(fprintf(stderr,"(%s) Exists returning existent\n",str));
				return hl->next->data;
			};
		};
		hl=hl->next;	
	};
	IFDEBUG(fprintf(stderr,"(%s) Doesn't Exists Creating new\n",str));
	/* Doesn't exists	 */
	strsize=strlen(str);
	hl->next=add_buffer(ClientInfo->mem,sizeof(struct _Header));
	hl->next->id=add_buffer(ClientInfo->mem,strsize+1);
	memcpy(hl->next->id,str,strsize);
	hl->next->id[strsize]=0;	
	hl->next->data=defret;
	hl->next->next=NULL;

        tmp3=mymalloc(strsize+3);
        snprintf(tmp3,strsize+3,"%s: ",str);
        tmp1=strstr(current_web_client->rbuf,tmp3);
        myfree(tmp3);
        if(tmp1==NULL) {
                return defret;
        };
        tmp1+=strsize+2;
        tmp2=strstr(tmp1,"\r\n");
        if(tmp2==NULL) { // Unexpected (security anyway)
                return defret;
        };
        size=(unsigned int)(tmp2-tmp1);
        if(size<0) {
                return defret;
        };
        ret=add_buffer(ClientInfo->mem,size+1); //malloc & register
	if(ret==NULL) {
		return defret;
	};
	memcpy(ret,tmp1,size);
	ret[size]=0;
	hl->next->data=ret;
	return ret;
}                                

char *__Query(char *handle) {
        char *tmp1,*tmp2,*tmp3,*ret;
	char *defret="";
	size_t strsize;
        size_t size;
        int i,j=0,ch;
	struct _Query *ql=ClientInfo->QueryList;
	if(ClientInfo->QueryList==NULL) {
		ClientInfo->QueryList=add_buffer(ClientInfo->mem,sizeof(struct _Query));
		ClientInfo->QueryList->next=NULL;
		ClientInfo->QueryList->data=NULL;
		ClientInfo->QueryList->id=NULL;
		ql=ClientInfo->QueryList;
	};
	// First search if exists
	IFDEBUG(fprintf(stderr,"Entering in Query\n"));
	while(ql->next!=NULL) {
		if(ql->next->id!=NULL) {
			if(!strcmp(ql->next->id,handle)) {
				IFDEBUG(fprintf(stderr,"(%s) Exists returning existent\n",handle));
				return ql->next->data;
			};
		};
		ql=ql->next;	
	};
	IFDEBUG(fprintf(stderr,"(%s) Doesn't Exists Creating new\n",handle));
	/* Doesn't exists	 */
	strsize=strlen(handle);
	ql->next=add_buffer(ClientInfo->mem,sizeof(struct _Query));
	ql->next->id=add_buffer(ClientInfo->mem,strsize+1);
	memcpy(ql->next->id,handle,strsize);
	ql->next->id[strsize]=0;	
	ql->next->data=defret;
	ql->next->next=NULL;

        tmp1=strstr(current_web_client->rbuf,"?"); // i don't know if this is standard
        tmp2=strstr(current_web_client->rbuf,"HTTP");
        if(tmp1!=NULL && tmp1<tmp2) {
                tmp1+=1;
	} else {
                return defret;
	}
        tmp2=strstr(tmp1,handle);
        if(tmp2!=NULL) {
                if(!(*(tmp2-1)=='?' || *(tmp2-1)=='&')) {
                        return defret;
                };
                tmp3=strstr(tmp2,"=");
                if(tmp3==NULL) { // search for equal, if not return null
                        return defret;
                }
                tmp1=strstr(tmp2,"&");
                if(tmp1<tmp3 && tmp1!=NULL) {        // if is just only ?something&other=blah
                        return defret;
                };
                tmp2+=strlen(handle)+1;
                tmp3=strstr(tmp2," HTTP");
                if(tmp1==NULL || (unsigned int)tmp1>(unsigned int)tmp3) {
                        size=tmp3-tmp2; // MUST HAVE else, server don't let in
                } else {
                        size=tmp1-tmp2;
                };
                if(size==0) {
                        return defret;
                };
		IFDEBUG(fprintf(stderr,"clientinfo.c: (allocating getquerystringval): ");fflush(stderr);); // REMOVE
                ret=add_buffer(ClientInfo->mem,size+1);
                for(i=0;i<size;i++) { // unicode translation here
                        switch (ch=tmp2[j]) {
                                case '+':
                                        ch=' ';
                                        break;
                                case '%':
					IFDEBUG(fprintf(stderr,"clientinfo.c (allocating sub-getquerystringval): ");fflush(stderr);); // REMOVE
                                        tmp1=mymalloc(3);
                                        strncpy(tmp1,&tmp2[j+1],2);
                                        tmp1[2]=0;
                                        IFDEBUG(fprintf(stderr,"Hex val:%s\n",tmp1));
                                        ch=hextoi(tmp1);
                                        j+=2;
                                        size-=2;
					IFDEBUG(fprintf(stderr,"clientinfo.c (freeing sub-getquerystringval): ");fflush(stderr);); // REMOVE
                                        myfree(tmp1);
                                        break;
                        };
                        ret[i]=ch;
                        j++;
                };
                //strncpy(ret,tmp2,size);
                ret[size]='\0';
 
        } else {
                return defret;
        };
	ql->next->data=ret;
        // We've got our string, now we must transform (unicode)
        return ret;
}                                                                                          

char *__Post(char *handle) {
        char *tmp1,*tmp2,*tmp3,*ret;
	struct _Post *pl=ClientInfo->PostList;
	char *defret="";
	size_t strsize;
        size_t size;
        int i,j=0,ch;
	IFDEBUG(fprintf(stderr,"Entered in Post\n"));
	tmp1=strstr(current_web_client->rbuf,"Content-type: multipart/form-data"); // multipart this post doesn't work
	if(tmp1!=NULL) {
		return ClientInfo->MultiPart(handle).data;
		//return defret;
	};
	if(ClientInfo->PostList==NULL) {
		ClientInfo->PostList=add_buffer(ClientInfo->mem,sizeof(struct _Post));
		ClientInfo->PostList->next=NULL;
		ClientInfo->PostList->data=NULL;
		ClientInfo->PostList->id=NULL;
		pl=ClientInfo->PostList;
	};
	// First search if exists
	while(pl->next!=NULL) {
		if(pl->next->id!=NULL) {
			if(!strcmp(pl->next->id,handle)) {
				IFDEBUG(fprintf(stderr,"(%s) Exists returning existent\n",handle));
				return pl->next->data;
			};
		};
		pl=pl->next;	
	};
	IFDEBUG(fprintf(stderr,"(%s) Doesn't Exists Creating new\n",handle));
	/* Doesn't exists	 */
	strsize=strlen(handle);
	pl->next=add_buffer(ClientInfo->mem,sizeof(struct _Post));
	pl->next->id=add_buffer(ClientInfo->mem,strsize+1);
	memcpy(pl->next->id,handle,strsize);
	pl->next->id[strsize]=0;	
	pl->next->data=defret;
	pl->next->next=NULL;


        tmp1=strstr(current_web_client->rbuf,"\r\n\r\n"); // i don't know if this is standard
        if(tmp1!=NULL)
                tmp1+=4;
        else
                return defret;
        tmp2=strstr(tmp1,handle);
        if(tmp2!=NULL) {
                if(!(*(tmp2-1)=='\n' || *(tmp2-1)=='&')) { // must be start or after end of var
                        return defret;
                };
                tmp3=strstr(tmp2,"=");
                if(tmp3==NULL) { // search for equal, if not return null
                        return defret;
                }
                tmp1=strstr(tmp2,"&");
                if(tmp1<tmp3 && tmp1!=NULL) {        // if is just only ?something&other=blah
                        return defret;
                };
                tmp2+=strlen(handle)+1;
                if(tmp1==NULL) {
                        size=strlen(tmp2);
                } else {
                        size=tmp1-tmp2;
                };
                if(size==0) {
                        return defret;
                };
		IFDEBUG(fprintf(stderr,"clientinfo.c (allocating getpostval): ");fflush(stderr);); // REMOVE
                ret=add_buffer(ClientInfo->mem,size+1);
                for(i=0;i<size;i++) { // unicode translation here
                        switch (ch=tmp2[j]) {
                                case '+':
                                        ch=' ';
                                        break;
                                case '%':
					IFDEBUG(fprintf(stderr,"clientinfo.c (allocating sub-getpostval): ");fflush(stderr);); // REMOVE
                                        tmp1=mymalloc(3);             
          				strncpy(tmp1,&tmp2[j+1],2);
                                        tmp1[2]=0;
                                        IFDEBUG(fprintf(stderr,"Hex val:%s\n",tmp1));
                                        ch=hextoi(tmp1);
                                        j+=2;
                                        size-=2;
					IFDEBUG(fprintf(stderr,"clientinfo.c (freeing sub-getpostval): ");fflush(stderr);); // REMOVE
                                        myfree(tmp1);
                                        break;
                        };
                        ret[i]=ch;
                        j++;
                };
                //strncpy(ret,tmp2,size);
                ret[size]='\0';
 
        } else {
                return defret;
        };
	pl->next->data=ret;
        return ret;
}                                                        


//#undef IFDEBUG
//#define IFDEBUG(x) x

struct _MultiPart __MultiPart(char *handle) {
	char *tmp1,*tmp2,*tmp3;	
	int i;
	char *name;
	size_t namesize;
	struct _MultiPart *ml=ClientInfo->MultiPartList;
	struct _MultiPart defret={"","",0,""};
	size_t strsize;
	char *boundary; size_t boundarysize;
	// IE C43o6Fn6Et74e65n6Et74-2DT54y79p70e65:3A 20m6Du75l6Ct74i69p70a61r72t74/2Ff66o6Fr72m6D-2Dd64a61t74a61
	// NS C43o6Fn6Et74e65n6Et74-2Dt74y79p70e65:3A 20m6Du75l6Ct74i69p70a61r72t74/2Ff66o6Fr72m6D-2Dd64a61t74a61
	tmp1=strcasestr(current_web_client->rbuf,"Content-type: multipart/form-data");	
	if(tmp1==NULL) return defret;
	if(ClientInfo->MultiPartList==NULL) {
		ClientInfo->MultiPartList=add_buffer(ClientInfo->mem,sizeof(struct _MultiPart));
		ClientInfo->MultiPartList->next=NULL;
		ClientInfo->MultiPartList->id=NULL;
		ClientInfo->MultiPartList->data=NULL;
		ClientInfo->MultiPartList->filename=NULL;
		ClientInfo->MultiPartList->size=0;
		ml=ClientInfo->MultiPartList;
	};
	// Check if handle exists
	while(ml->next!=NULL) {
		if(ml->next->id!=NULL) {
			if(!strcmp(ml->next->id,handle)) {
				IFDEBUG(fprintf(stderr,"(%s) Exists returning existent\n",handle));
				return *ml->next;
			};
		};
		ml=ml->next;
	};	
	
	IFDEBUG(fprintf(stderr,"(%s) doesn't exists Creating new\n",handle));
	strsize=strlen(handle);
	ml->next=add_buffer(ClientInfo->mem,sizeof(struct _MultiPart));
	ml->next->id=add_buffer(ClientInfo->mem,strsize+1);
	memcpy(ml->next->id,handle,strsize);
	ml->next->id[strsize]=0;
	ml->next->data="";
	ml->next->filename="";
	ml->next->size=0;
	ml->next->next=NULL;
	
	tmp1=strstr(tmp1,"boundary=");
	if(tmp1==NULL) return defret;
	tmp1+=9;
	tmp2=strstr(tmp1,"\r\n");
	if(tmp2<tmp1 || tmp2==NULL) return defret;
	/* boundary */
	boundarysize=tmp2-tmp1;
	boundary=add_buffer(ClientInfo->mem,boundarysize+3);
	memcpy(boundary,tmp1,boundarysize);
	boundary[boundarysize]=0;
	
	IFDEBUG(fprintf(stderr,"Boundary is \"%s\"\n",boundary));
	/* handle */	
	namesize=boundarysize+41+strlen(handle);
	name=add_buffer(ClientInfo->mem,namesize+1);
	snprintf(name,namesize,"%s\r\nContent-Disposition: form-data; name=",boundary,handle);	
	namesize=strlen(name);
	IFDEBUG(fprintf(stderr,"handle name is \"%s\"\n",name));	
	tmp1=strstr(tmp1,"\r\n\r\n"); // go to data
	if(tmp1==NULL) return defret;
	IFDEBUG(fprintf(stderr,"tmp1 is \"%s\"\n",tmp1));
	do {
		i=memcmp(tmp1,name,namesize);	
		if(i==0) {
			tmp1+=namesize;
			if(tmp1[0]=='\"')tmp1+=1;
			if(strncmp(tmp1,handle,strlen(handle))){
				i=1;
			}else {
				if((tmp1[strsize]!=' ') && (tmp1[strsize]!='\"') && (tmp1[strsize]!='\r') && (tmp1[strsize]!=';') ) i=1;
			};

		}else { 
			tmp1+=1;
		};
	} while(i!=0 && (tmp1+namesize<current_web_client->rbuf+current_web_client->rbufsize)); // Search init of data
	if(i!=0) return defret;
	//tmp1+=namesize;
	tmp2=strstr(tmp1,"filename="); // get filename
	if(tmp2!=NULL) {
		tmp2+=9;
		if(tmp2[0]=='\"')tmp2+=1;
		tmp3=strstr(tmp2,"\r\n");
		ml->next->filename=add_buffer(ClientInfo->mem,(tmp3-tmp2)+1);
		memcpy(ml->next->filename,tmp2,tmp3-tmp2);
		ml->next->filename[tmp3-tmp2]='\0';
		if(ml->next->filename[tmp3-tmp2-1]=='\"')
			ml->next->filename[tmp3-tmp2-1]='\0';
		IFDEBUG(fprintf(stderr,"Filename found and is \"%s\"\n",ml->next->filename));
	};
	tmp2=strstr(tmp1,"\r\n\r\n"); // data init
	if(tmp2==NULL)return defret;
	tmp2+=4;
	tmp3=tmp2;
	do {	
		
		i=memcmp(tmp3,boundary,boundarysize);  
		if(i!=0)tmp3+=1;
	} while(i!=0 && (tmp3+boundarysize<current_web_client->rbuf+current_web_client->rbufsize)); // End of data
	if(i!=0) return defret;
	tmp3-=4; // back "\r\n\r\n"

	// copy data to node	
	ml->next->data=add_buffer(ClientInfo->mem,(tmp3-tmp2)+1);
	memcpy(ml->next->data,tmp2,tmp3-tmp2);
	ml->next->data[tmp3-tmp2]='\0';
	ml->next->size=tmp3-tmp2;
	IFDEBUG(fprintf(stderr,"Data is \""));
	IFDEBUG(fwrite(ml->next->data,ml->next->size,1,stderr));
	IFDEBUG(fprintf(stderr,"\"\n"));
	
	return *ml->next;

};
//#undef IFDEBUG
//#define IFDEBUG(x)

/*
 * get whole query string (NEW)
 */
char *clientinfo_getquerystring() {
	char *tmp1,*tmp2,*ret;
	char *defret="";
	size_t size;
        tmp1=strstr(current_web_client->rbuf,"?"); // i don't know if this is standard
        tmp2=strstr(current_web_client->rbuf,"HTTP");
        if(tmp1!=NULL && tmp1<tmp2)
                tmp1+=1;
        else
                return defret;
	size=(tmp2-tmp1)-1;
	ret=add_buffer(ClientInfo->mem,size+1);
	memcpy(ret,tmp1,size);
	ret[size]=0;
	return ret;
};

char *clientinfo_getpostdata() {
	char *tmp1,*tmp2,*tmp3,*ret;
	char *defret="";
	size_t size;
	int i,j=0,ch;
	tmp1=strstr(current_web_client->rbuf,"\r\n\r\n"); // i don't know if this is standard
	if(tmp1!=NULL && (tmp1+4)<(char*)(current_web_client->rbuf+current_web_client->rbufsize))
		tmp1+=4;
	else
		return defret;
	size=(current_web_client->rbuf+current_web_client->rbufsize)-tmp1;
	ret=add_buffer(ClientInfo->mem,size+1);
	memcpy(ret,tmp1,size);
	ret[size]='\0';
	return ret;
}

/* 
 * Get authorization line
 */
char *clientinfo_getauthuser() {
	char *tmp1,*tmp2,*ret, *out=NULL;
	char *defret="";
	size_t size;
	IFDEBUG(fprintf(stderr,"Cheking for Authorization: Basic (username)\n"));
	tmp1=strstr(current_web_client->rbuf,"Authorization: Basic");
	if(tmp1==NULL) {
		IFDEBUG(fprintf(stderr,"Not found\n"));
		return defret;
	};
	IFDEBUG(fprintf(stderr,"Found (fetching username)\n"));
	tmp1+=21;
	tmp2=strstr(tmp1,"\r\n");
	size=(int)(tmp2-tmp1);
	IFDEBUG(fprintf(stderr,"clientinfo.c (allocating sub-getauthuser): ");fflush(stderr);); // REMOVE
	ret=mymalloc(size+1);
	memcpy(ret,tmp1,size);
	ret[size]=0;
	IFDEBUG(fprintf(stderr,"clientinfo.c (allocating sub-getauthuser): ");fflush(stderr);); // REMOVE
	out=mymalloc(size+1);
	IFDEBUG(fprintf(stderr,"Decoding ret to out\n"));
	size=base64decode(out,ret);
	out[size]='\0';
	IFDEBUG(fprintf(stderr,"out=%p size=%d\n",out,size));
	IFDEBUG(fprintf(stderr,"clientinfo.c (freeing sub-getauthuser): ");fflush(stderr);); // REMOVE
	myfree(ret);
	tmp2=strstr(out,":");
	IFDEBUG(fprintf(stderr,"clientinfo.c (allocating getauthuser): ");fflush(stderr);); // REMOVE
	ret=add_buffer(ClientInfo->mem,(tmp2-out)+1);
	memcpy(ret,out,tmp2-out);
	ret[tmp2-out]=0;
	IFDEBUG(fprintf(stderr,"clientinfo.c (freeing sub-getauthuser): ");fflush(stderr);); // REMOVE
	myfree(out);
	return ret;
}
char *clientinfo_getauthpass() {
	char *tmp1,*tmp2,*ret, *out=NULL;
	char *defret="";
	size_t size;
	IFDEBUG(fprintf(stderr,"Cheking for Authorization: Basic (password)\n"));
	tmp1=strstr(current_web_client->rbuf,"Authorization: Basic");
	if(tmp1==NULL) {
		IFDEBUG(fprintf(stderr,"Not found\n"));
		return defret;
	};
	IFDEBUG(fprintf(stderr,"Found (fetching password)\n"));
	tmp1+=21;
	tmp2=strstr(tmp1,"\r\n");
	size=(int)(tmp2-tmp1);
	IFDEBUG(fprintf(stderr,"clientinfo.c (allocating sub-getauthpass): ");fflush(stderr);); // REMOVE
	ret=mymalloc(size+1);
	memcpy(ret,tmp1,size);
	ret[size]=0;
	IFDEBUG(fprintf(stderr,"clientinfo.c (allocating sub-getauthpass): ");fflush(stderr);); // REMOVE
	out=mymalloc(size+1);
	IFDEBUG(fprintf(stderr,"Decoding ret to out\n"));
	size=base64decode(out,ret);
	out[size]='\0';
	IFDEBUG(fprintf(stderr,"out=%p size=%d\n",out,size));
	IFDEBUG(fprintf(stderr,"clientinfo.c (freeing sub-getauthpass): ");fflush(stderr);); // REMOVE
	myfree(ret);
	tmp1=strstr(out,":")+1;
	tmp2=out+strlen(out);
	IFDEBUG(fprintf(stderr,"clientinfo.c (allocating getauthpass): ");fflush(stderr);); // REMOVE
	ret=add_buffer(ClientInfo->mem,(tmp2-tmp1)+1);
	memcpy(ret,tmp1,tmp2-tmp1);
	ret[tmp2-tmp1]=0;
	IFDEBUG(fprintf(stderr,"clientinfo.c (freeing sub-getauthpass): ");fflush(stderr);); // REMOVE
	myfree(out);
	return ret;
}

char *clientinfo_getmethod() {
	char *tmp1,*ret;
	char *defret="";
	size_t size;
	tmp1=strstr(current_web_client->rbuf," "); // first space
	if(tmp1==NULL) {
		return defret;
	};
	size=tmp1-current_web_client->rbuf;
	ret=add_buffer(ClientInfo->mem,size+1);
	memcpy(ret,current_web_client->rbuf,size);
	ret[size]=0;
	return ret;
}
char *clientinfo_getreqname() {
        char *ret;
        char *tmp1=strstr(current_web_client->rbuf,"/"); // Must have /
        char *tmp2=strstr(tmp1,"?");
        char *tmp3=strstr(tmp1," HTTP");
	char *defret="";
        size_t size=0;
        if(tmp2==NULL || tmp2>tmp3) {
                tmp2=tmp3;
        };
        size=tmp2-tmp1;
        ret=add_buffer(ClientInfo->mem,size+1);
        memcpy(ret,tmp1,size);
        ret[size]=0;
        return ret;
}             
