/* by Luis Figueiredo (stdio@netc.pt)
 *
 *
 * date: Sat Mar 30 14:25:25 GMT 2002 
 *
 *  memory functions
 */
#include "outstream.h"


int add_outstream(struct outstream *list,FILE *fstream){
	struct outstream *temp=list;
	if(fstream==NULL) return 0;
	while(temp->next!=NULL)temp=temp->next;
	IFDEBUG(fprintf(stderr,"outstream.c (allocating outstream): ");fflush(stderr);); // REMOVE
	temp->next=mymalloc(sizeof(struct outstream));
	temp->next->fstream=fstream;
	temp->next->wsize=1;
	temp->next->rsize=0;
	temp->next->next=NULL;	
	return 1;	
}

struct outstream *init_outstream_list() {
	struct outstream *ret;
	IFDEBUG(fprintf(stderr,"Adding Head to outstream\n"));
	IFDEBUG(fprintf(stderr,"outstream.c (allocating outstream list): ");fflush(stderr);); // REMOVE
	ret=mymalloc(sizeof(struct outstream));
	ret->next=NULL;
	ret->fstream=NULL;
	return ret;
}

void delete_outstream(struct outstream *node) {
	if(node->fstream!=NULL) {
		fclose(node->fstream);
	};
	IFDEBUG(fprintf(stderr,"outstream.c (freeing outstream): ");fflush(stderr);); // REMOVE
	myfree(node);
}

void delete_next_outstream(struct outstream *node) {
	struct outstream *temp=node->next;
	node->next=node->next->next;
	delete_outstream(temp);
}

void delete_outstream_list(struct outstream *list) {
	struct outstream *temp=list;
	while(temp->next!=NULL) {
		delete_next_outstream(temp);
	};
	delete_outstream(temp);
	
}

